﻿using PrintPreviewControl;
using Prism.Commands;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Input;

namespace StimulSoftPOC.ViewModels
{
    public class MainWindowViewModel : BindableBase
    {
        private string _title = "Prism Application";


        public string Title
        {
            get { return _title; }
            set { SetProperty(ref _title, value); }
        }
        public ICommand GenerateReportCommand { get; set; }
        private List<ReportColumn> _reportCoumner = new List<ReportColumn>();

        public ObservableCollection<ReportColumn> ReportHeaders { get; set; }

        public string Header { get; set; }

        public string Footer { get; set; }
        public ICommand PrintMissingPaxCmd { get; set; }

        public MainWindowViewModel()
        {
            this.PrintMissingPaxCmd = new DelegateCommand(() => this.PrintMissingPaxCmdEvent());
            GenerateReportCommand = new DelegateCommand<String>(GenerateReport);
            ReportHeaders = new ObservableCollection<ReportColumn> {
                new ReportColumn
                {
                    Id=1,
                    ColumnDataName="CarrierCode",
                   ColumnHeaderName="CarrierCode",
                   Position=Position.Header

                },
                      new ReportColumn
                {
                          Id=2,
                   ColumnDataName="FlightNumber",
                   ColumnHeaderName="FlightNumber",
                   Position=Position.Header

                },
                 new ReportColumn
                {
                     Id=3,
                   ColumnDataName="DepartureDate",
                   ColumnHeaderName="Date of Departure",
                   Position=Position.Header

                },
                 new ReportColumn
                {
                     Id=4,
                   ColumnDataName="ArrivalAirport",
                   ColumnHeaderName="ArrivalAirport",
                   Position=Position.Header

                },
                 new ReportColumn
                {
                     Id=4,
                   ColumnDataName="ETD",
                   ColumnHeaderName="ETD",
                   Position=Position.Header

                },
                  new ReportColumn
                {
                     Id=4,
                   ColumnDataName="AircraftConfig",
                   ColumnHeaderName="AircraftConfig",
                   Position=Position.Header

                },
                       new ReportColumn
                {
                     Id=4,
                   ColumnDataName="BaggageConfig",
                   ColumnHeaderName="BaggageConfig",
                   Position=Position.Header

                },
                                new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Lastname",
                   ColumnHeaderName="Pax Lastname",
                   Position=Position.Detail

                },
                  new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Firstname",
                   ColumnHeaderName="Pax Firstname",
                   Position=Position.Detail


                },
                        new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Destination",
                   ColumnHeaderName="Pax Destination",
                   Position=Position.Detail


                },
                              new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Seat",
                   ColumnHeaderName="Pax Seat",
                   Position=Position.Detail


                },
                                           new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Gender",
                   ColumnHeaderName="Pax Gender",
                   Position=Position.Detail


                },
                                                     new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Baggage ",
                   ColumnHeaderName="Pax Baggage",
                   Position=Position.Detail


                },
                                                                              new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax Seq ",
                   ColumnHeaderName="Pax Seq",
                   Position=Position.Detail


                },
                                                                                                                                              new ReportColumn
                {
                     Id=4,
                   ColumnDataName="Pax BagTag ",
                   ColumnHeaderName="Pax BAgTag",
                   Position=Position.Detail


                },
            };
        }

        private void PrintMissingPaxCmdEvent()
        {
            PreviewControl contrl = new PreviewControl();
            contrl.Show();
        }

        private void GenerateReport(string obj)
        {
            //StiReport report = new StiReport();

            //report.RegData("PassengerList", BuildPassengerList());
            ////Fill dictionary
            //report.Dictionary.Synchronize();

            //StiPage page = report.Pages[0];

            ////Create HeaderBand
            //StiHeaderBand headerBand = new StiHeaderBand
            //{
            //    Height = 0.5,
            //    Name = "HeaderBand"
            //};
            //page.Components.Add(headerBand);

            ////Create text on header
            //StiText headerText = new StiText(new RectangleD(0, 0, 5, 0.5))
            //{
            //    Text = Header,
            //    HorAlignment = StiTextHorAlignment.Center,
            //    Name = "HeaderText",
            //    Brush = new StiSolidBrush(System.Drawing.Color.LightGreen)
            //};
            //headerBand.Components.Add(headerText);

            ////Create Databand
            //StiDataBand dataBand = new StiDataBand();
            //dataBand.DataSourceName = "Customers";
            //dataBand.Height = 0.5;
            //dataBand.Name = "DataBand";
            //page.Components.Add(dataBand);
            //double position = 0;

            //foreach (var item in ReportHeaders)
            //{

            //    //Create text
            //    StiText dataText = new StiText(new RectangleD(position, 0, 2, 0.5))
            //    {
            //        Text = "{Line}.{Passenger." + item.ColumnDataName + "}",
            //        Name = item.ColumnDataName,

            //    };
            //    dataBand.Components.Add(dataText);

            //    position += page.Width/ReportHeaders.Count;
            //}


            ////Create FooterBand
            //StiFooterBand footerBand = new StiFooterBand
            //{
            //    Height = 0.5,
            //    Name = "FooterBand"
            //};
            //page.Components.Add(footerBand);

            ////Create text on footer
            //StiText footerText = new StiText(new RectangleD(0, 0, 5, 0.5))
            //{
            //    //   Text = "Count - {Count()}",
            //    Text = Footer,
            //    HorAlignment = StiTextHorAlignment.Right,
            //    Name = "FooterText",
            //    Brush = new StiSolidBrush(System.Drawing.Color.LightGreen)
            //};
            //footerBand.Components.Add(footerText);



            //report.DesignWithWpf();
        }

        private object BuildPassengerList()
        {
            return null;
        }
    }
}
